; Fire One 2600
;
; 2600 Programming For Newbies project
;
; Compiles with DASM
;
; Build command:
; dasm fireone.s -f3 -lfire.txt -ofire.bin -v3
;
; History
;
; 07.03.2K4     - Started
; 07.03.2K4     - Bankswitching skeleton provided by MR


    processor  6502
    include    vcs.h
    include    macro.h

;----------------------------------------------------------
; 4K GAME
;----------------------------------------------------------

; Compile switches

NTSC                    = 0
PAL                     = 1 
COMPILE_VERSION         = NTSC

    SEG.U vars
    ORG $80

; Both Banks:
gameState       ds 1
bcdScore        ds 1
frameCounter    ds 1
rnd             ds 1
tempVar1        ds 1
tempVar2        ds 1
tempVar3        ds 1
tempVar4        ds 1

;---------------
; Main Display
;---------------

mainVariable1	ds 1

;---------------
; State Display
;---------------

stateVariable1	ds 1

;---------------
; Sonar
;---------------

sonarVariable	ds 1


    SEG     Bank0
    ORG     $1000
    RORG    $D000

MainGame
    JMP SwitchToBank1

;------------------
; Main Display code
;------------------



;-------------------
; State Display code
;-------------------



;------------
; Sonar code
;------------

FirstInit
    BIT $1FF9
    NOP             ; dummy

SwitchToBank1:
    BIT $1FF9
    JMP MainGame

    .word $FFFF, $FFFF  ; bank-switching hotspots
    .word FirstInit
    .word FirstInit
    .word FirstInit

    SEG.U   variables
    ORG     $80

; Both Banks:
gameState       ds 1
bcdScore        ds 1
frameCounter    ds 1
rnd             ds 1
tempVar1        ds 1
tempVar2        ds 1
tempVar3        ds 1
tempVar4        ds 1

;-------
; Intro
;-------

introVariable1	ds 1

;---------
; Network
;---------

netVariable1	ds 1

    SEG     Bank1
    ORG     $2000
    RORG    $F000

start
    CLEAN_START

Intro
    JMP SwitchToBank0

;------------
; Intro code 
;------------


;--------------
; Network code 
;--------------

    ORG     $2FEF
    RORG    $FFEF

    BRK                     ; coming from the other bank

SwitchToBank0
    BIT $1FF8
    JMP Intro

    .word $FFFF, $FFFF      ; bank-switching hotspots
    .word start
    .word start
    .word start